import {createRouter, createWebHashHistory, RouteRecordRaw} from 'vue-router'

// 基本页面
const basePages = {
    // design: () => import('@/pages/Design.vue'),
    // studio: () => import('@/pages/Studio.vue'),
    // 404: () => import('@/components/NotFound.vue'),
}

/** 获取路由数据 */
async function getRoutes(): Promise<RouteRecordRaw[]> {
    const routes: RouteRecordRaw[] = [];
    // 全局404页面
    routes.push({path: "/:pathMatch(.*)*", component: basePages["404"]});
    return routes;
}

/** 全局的路由对象 */
const router = createRouter({
    history: createWebHashHistory(),
    routes: [],
    strict: true,
    sensitive: true,
});

/** 删除路由的钩子函数 */
const removeRoutesFuc: Array<() => void> = [];

/** 初始化路由 */
async function initRouter() {
    // system.setStudioRequest(request)

    const routes = await getRoutes();
    removeRoutesFuc.forEach(removeRoute => removeRoute());
    removeRoutesFuc.length = 0;
    routes.forEach(route => removeRoutesFuc.push(router.addRoute(route)));
    router.addRoute({
        name: "design",
        path: "/design",
        component: basePages.design,
    })
    router.addRoute({
        name: "studio",
        path: "/studio",
        component: basePages.studio,
    })
}

export {
    initRouter,
    router,
};
